<template>
  <div class="py-8 px-4 lg:py-16 lg:px-12">
    <UBreadcrumb :links="links" />
    <h1 class="text-3xl mt-6 font-bold dark:text-white">Profil</h1>
    <div class="grid grid-cols-2 gap-4 mb-4">
      <div>
        <UCard class="my-5">
          <div class="flex items-center mb-5">
            <UAvatar
                v-if="user.isAdmin"
                chip-color="primary"
                chip-text="Admin"
                chip-position="top-right"
                size="3xl"
                :src="'https://api.dicebear.com/9.x/personas/svg?radius=50&seed=' + user.username"
                alt="Avatar"
            />
            <UAvatar
                v-else
                size="3xl"
                :src="'https://api.dicebear.com/9.x/personas/svg?radius=50&seed=' + user.username"
                alt="Avatar"
            />
            <div class="ml-5">
              <h1 class="text-2xl font-bold dark:text-white capitalize">{{ user.username }}</h1>
              <h2 class="text-lg dark:text-white">{{ user.email }}</h2>
            </div>
          </div>
          <UDivider label="Info générale" />
          <div class="mt-5">
            <p>Date création compte : {{ createdAt }}</p>
            <p>Nombre d'articles aimé : 10</p>
          </div>
        </UCard>
      </div>
      <div>
        <UCard class="my-5">
          <UForm :schema="schema" :state="state" class="space-y-4 md:space-y-6" @submit="onSubmit">
            <UFormGroup label="Votre nom" name="email" class="block mb-2 text-sm font-medium !text-gray-900">
              <UInput type="text" v-model="state.username" placeholder="jhon@example.com" inputClass="!bg-gray-50 !text-gray-900 sm:text-sm rounded-lg block w-full p-2.5" />
            </UFormGroup>
            <UFormGroup label="Votre Email" name="password" class="block mb-2 text-sm font-medium !text-gray-900">
              <UInput type="emal" v-model="state.email" placeholder="••••••••" inputClass="!bg-gray-50 !text-gray-900 sm:text-sm rounded-lg block w-full p-2.5" />
            </UFormGroup>
            <p v-if="error" class="text-sm font-light text-red-500">{{ error }}</p>
            <div class="flex items-center justify-between">
              <a href="#" class="text-sm font-medium text-primary-600 hover:underline">
                Modifier mot de passe ?
              </a>
            </div>
            <UButton type="submit" :loading="loading" class="w-full text-white bg-primary-600 hover:bg-primary-700 focus:ring-4 focus:outline-none focus:ring-primary-300 font-medium rounded-lg text-sm px-5 py-2.5 text-center">
              Modifier
            </UButton>
          </UForm>
        </UCard>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import {useAuthStore} from "~/store/auth"
import moment from 'moment'
import {type InferType, object, string} from "yup";
import type {FormSubmitEvent} from "#ui/types";
import {useNuxtApp} from "#app";
import type {Api} from "~/types/api";

const { user } = storeToRefs(useAuthStore())
const authStore = useAuthStore()
const { authenticated } = storeToRefs(useAuthStore())
const router = useRouter();
const loading = ref(false)
const error = ref('')

const links = [{
  label: 'Home',
  icon: 'i-heroicons-home',
  to: '/feed'
}, {
  label: 'Profil',
  icon: 'i-heroicons-user'
}]

const createdAt = computed(() => {
  return moment(user.value.createdAt).format('DD/MM/YYYY')
})

const schema = object({
  email: string().email('Le format de l\'email est invalide').required('Champ obligatoire'),
  username: string()
      .required('Champ obligatoire')
})

type Schema = InferType<typeof schema>

const state = reactive({
  username: user.value.username,
  email: user.value.email
})

const nuxtApp = useNuxtApp()
const $api = nuxtApp.$api as Api
const toast = useToast()

async function onSubmit (event: FormSubmitEvent<Schema>) {
  const user = ref({
    email: event.data.email,
    username: event.data.username
  })
  const response = await $api.updateUser(user.value)
  if (response) {
    toast.add({ title: 'Modification enregistré' })
  }
}
</script>